Attribute VB_Name = "Sample"
'*****************************************************************************
'* aisa29s.bas
'*
'* aISA-M29
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/06/01
'*
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'*
'*****************************************************************************
Option Explicit

Private Const szM29 = "aISA-M29"
Private Declare Function GetLastError Lib "kernel32" () As Long

Sub Main()

    Dim strbuf As String                ' ʕ\p
    Dim dwDllVer As Long                ' DLL̃o[W
    Dim dwDrvVer As Long                ' Driver̃o[W
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim ri As AISA29RESOURCE            ' \[X
    Dim bMode As Byte                   ' [h
    Dim bStatus As Byte                 ' Xe[^X
    Dim dwCountData As Long             ' JE^f[^
    Dim dwCH1Data As Long               ' JXP[hpf[^P
    Dim dwCH2Data As Long               ' JXP[hpf[^Q

    '-------------------------------------------------------------------------
    ' aisa29.dll J
    '-------------------------------------------------------------------------
    If Aisa29wDllOpen() = False Then
        ErrorMessage (AISA29_SLOT_AUTO)
        Exit Sub                ' aisa29.dll ̃[hɎs܂B
    End If

    '-------------------------------------------------------------------------
    ' o[W\
    '-------------------------------------------------------------------------
    If Aisa29wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-M29DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA29_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

    '-------------------------------------------------------------------------
    ' aISA-M29 ̎gp錾
    '-------------------------------------------------------------------------
    wLogSlot = AISA29_SLOT_AUTO     ' gp̃foCXT܂B
    bResult = Aisa29wCreate(wLogSlot)    ' ꍇA̎̃foCXi[܂B

    If bResult = False Then         ' foCX܂B
        ErrorMessage (AISA29_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "aISA-M29 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

    '-------------------------------------------------------------------------
    ' \[X擾
    '-------------------------------------------------------------------------
    If Aisa29wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szM29 + Chr(10) + _
             "NumPorts: " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1)

    ResultMessage (strbuf)

    '-------------------------------------------------------------------------
    ' [hݒ
    '-------------------------------------------------------------------------
    bMode = 0
    bMode = bMode Or AISA29_CH1_CH2_COMPARATE_MODE Or AISA29_CH2_COMPARATE_MODE Or AISA29_CH1_COMPARATE_MODE
    ' CH2 CLEAR MODE = ONE TIME CLEAR MODE
    ' CH1 CLEAR MODE = ONE TIME CLEAR MODE
    ' CH1:CH2 COMPARETE MODE = 24bit 2i␔r
    ' CH2 COMPARETE MODE = 24(48)bit 2i␔r
    ' CH1 COMPARATE MODE = 24bit 2i␔r

    If Aisa29wModeSet(wLogSlot, bMode) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "ModeBit: &H" + Hex(bMode)
    ResultMessage (strbuf)
    
    '-------------------------------------------------------------------------
    ' C-REQ o
    '-------------------------------------------------------------------------
    ' C-REQ1
    If Aisa29wCreqWrite(wLogSlot, AISA29_CREQ_1) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    ' C-REQ2
    If Aisa29wCreqWrite(wLogSlot, AISA29_CREQ_2) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("C-REQ ɏo܂")
    
    '-------------------------------------------------------------------------
    ' JE^[ CH1 ɃR}ho
    '-------------------------------------------------------------------------

    ' QM͂P{JEg[h
    If Aisa29wDataWrite(wLogSlot, AISA29_CH1_2_PHASE_X1_MODE_SET, AISA29_COMMAND_SET_DATA) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    ResultMessage ("CH1 QM͂P{JEg[h")

    ' JE^[Cl[u
    If Aisa29wDataWrite(wLogSlot, AISA29_CH1_COUNT_ENABLE_SET, AISA29_COMMAND_SET_DATA) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    ResultMessage ("CH1 JE^[Cl[u")

    '-------------------------------------------------------------------------
    ' JE^[ CH1 Ƀf[^o
    '-------------------------------------------------------------------------
    dwCountData = 0
    ' 0 Zbg
    If Aisa29wDataWrite(wLogSlot, AISA29_CH1_COUNTER_WRITE, dwCountData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "CH1 CounterWrite" + Chr(10) + Chr(10) + _
             "0 Zbg܂"
    ResultMessage (strbuf)
    
    '-------------------------------------------------------------------------
    ' Xe[^Xǂݍ
    '-------------------------------------------------------------------------
    If Aisa29wGetStatus(wLogSlot, bStatus) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "Status: &H" + Hex(bStatus)
    ResultMessage (strbuf)
    
    '-------------------------------------------------------------------------
    ' JE^[ CH1 f[^ǂݍ
    '-------------------------------------------------------------------------
    If Aisa29wDataRead(wLogSlot, AISA29_CH1_COUNTER_READ, dwCountData) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "CH1 CounterRead" + Chr(10) + Chr(10) + _
             "&H" + Hex(dwCountData)
    ResultMessage (strbuf)
    
    '-------------------------------------------------------------------------
    ' JXP[ho
    '-------------------------------------------------------------------------
    dwCH1Data = &H0
    dwCH2Data = &H0

    If Aisa29wCascadeWrite(wLogSlot, dwCH1Data, dwCH2Data) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "CascadeWrite" + Chr(10) + Chr(10) + _
             "0 Zbg܂"
    ResultMessage (strbuf)
    
    '-------------------------------------------------------------------------
    ' JXP[hǂݍ
    '-------------------------------------------------------------------------
    If Aisa29wCascadeRead(wLogSlot, dwCH1Data, dwCH2Data) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "CascadeRead" + Chr(10) + Chr(10) + _
             "CH1 :&H" + Hex(dwCH1Data) + Chr(10) + _
             "CH2 :&H" + Hex(dwCH2Data)
    ResultMessage (strbuf)
    
    '-------------------------------------------------------------------------
    ' aISA-P31̎gpJ
    '-------------------------------------------------------------------------
    If Aisa29wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-M29 Closed")

    '-------------------------------------------------------------------------
    ' aisa29.dll ̎gpJ
    '-------------------------------------------------------------------------
    If Aisa29wDllClose() = False Then
        MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
        Exit Sub        ' aisa29.dll ̃A[hɎs܂B
    End If

End Sub

'---------------------------------------------------------------------------
' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub

'---------------------------------------------------------------------------
' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim dwSErr As Long
    Dim szbuf As String

    dwRes = Aisa29wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA29_ERR_SYSTEM
        dwSErr = GetLastError()
        szbuf = "System error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwSErr)
    Case AISA29_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-M29 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
